import * as angular from 'angular';
import NwfHelpModule from './help/nwfHelp-module';
import { NwfIcon, NwfIconFactory } from './icon/icon-directive';
import { NwfLoadingIndicator, NwfLoadingIndicatorFactory } from './loading-indicator/nwfLoadingIndicator-directive';
import { NwfPageAlert, NwfPageAlertFactory } from './page-alert/nwfPageAlert-directive';

import ShellModule from './shell/shell-module';
import FormModule from './form/form-module';
import NwfConfigProvider from './nwfConfig-provider';

export default class NwfComponentsModule {

    static NAME: string = 'nwfComponentsModule';

    static DEPENDENCIES: Array<string> = [
        'ui.router',
        ShellModule.NAME,
        FormModule.NAME,
        NwfHelpModule.NAME
    ];

    private native: angular.IModule;

    constructor() {
        this.initModules();
        this.native = angular.module(NwfComponentsModule.NAME, NwfComponentsModule.DEPENDENCIES);
        this.native.provider('nwfConfig', NwfConfigProvider);
        this.native.directive(NwfIcon.NAME, NwfIconFactory);
        this.native.directive(NwfLoadingIndicator.NAME, NwfLoadingIndicatorFactory);
        this.native.directive(NwfPageAlert.NAME, NwfPageAlertFactory);
    }

    initModules() {
        new ShellModule();
        new FormModule();
        new NwfHelpModule();
    }
}
