
import NwfValidator from '../nwfValidator';

class IsRequiredValidatorController extends NwfValidator {

    static $inject = ['$element'];

    constructor(private $element: ng.IAugmentedJQuery) {
        super($element);
        this.myEl.setAttribute('required', 'required');
        this.emptyMessage = this.emptyMessage || 'You have to provide a value';
        this.invalidMessage = this.invalidMessage || 'You have to provide a value';

        this.myEl.addEventListener('change', () => {
            if (this.myEl.tagName == 'SELECT') {
                this.resetCustomValidity();
            }
        });
    }
}

export class IsRequiredValidator {

    static NAME: string = 'isRequired';
    bindToController = {
        emptyMessage: '@?',
        invalidMessage: '@?'
    };
    restrict = 'A';
    controller = IsRequiredValidatorController;
    controllerAs = 'requiredCtrl';
}

// export factory function
export function IsRequiredValidatorFactory(): IsRequiredValidator {
    return new IsRequiredValidator();
}