import NwfValidator from '../nwfValidator';

class IsSameValidatorController extends NwfValidator {

    isSame: string;
    masterElement: HTMLInputElement;

    static $inject = ['$element'];

    constructor(private $element: ng.IAugmentedJQuery) {
        super($element);
        this.invalidMessage = this.invalidMessage || 'Value does not match previous value';
        this.emptyMessage = this.emptyMessage || 'You have to provide a value';
        //I connect events to the masterElement so if it changes somehow, I reset and revalidate MY (this) validity, and trigger validation when the master changes
        this.masterElement = <HTMLInputElement>document.getElementById(this.isSame);
        var inputHandler = this.resetCustomValidity.bind(this);
        this.masterElement.addEventListener('input', inputHandler);
        var blurHandler = function () { $element.trigger('focus'); if ($element.get(0)['hasBeenBlurred']) { $element.trigger('blur'); } };
        this.masterElement.addEventListener('blur', blurHandler);
        $element.on('$destroy', () => {
            this.masterElement.removeEventListener('input', inputHandler);
            this.masterElement.removeEventListener('blur', blurHandler);
        });
    }

    invalidHandler() {
        if (!this.myEl.value) {
            this.myEl.setCustomValidity(this.emptyMessage);
        } else if (this.myEl.value !== this.masterElement.value) {
            this.myEl.setCustomValidity(this.invalidMessage);
        } else {
            this.myEl.setCustomValidity('');
        }
    }

}

export class IsSameValidator {

    static NAME: string = 'isSame';
    bindToController = {
        isSame: '@',
        emptyMessage: '@?',
        invalidMessage: '@?'
    };
    restrict = 'A';
    controller = IsSameValidatorController;
    controllerAs = 'sameCtrl';
}

// export factory function
export function IsSameValidatorFactory(): IsSameValidator {
    return new IsSameValidator();
}
