import * as ng from 'angular';

export default class ExportController {

    private popoverPlacement = 'auto bottom-right';

    private isPopoverOpen = false;
    private gridParams: any;

    static $inject = ['$scope', '$timeout'];

    constructor(private $scope: angular.IScope, private $timeout) {
        this.preventBodyClick();
    }

    preventBodyClick() {
        // Connecting our outsideClick handler ourselves
        var bodyEl = document.body;
        var onBodyClick = (evt) => {
            var target = ng.element(evt.target);
            if (target.closest('[class^="nwf-grid-export"]').length) {
                return;
            } else {
                this.isPopoverOpen = false;
                this.$timeout(() => this.$scope.$digest());
            }
        };

        bodyEl.addEventListener('click', onBodyClick);
        //Removing handler upon destruction
        this.$scope.$on('$destroy', function () {
            bodyEl.removeEventListener('click', onBodyClick);
        });
    }

    togglePopover() {
        this.isPopoverOpen = !this.isPopoverOpen;
    }

    downloadFile() {
        var gridParams = ng.copy(this.gridParams);
        gridParams.offset = 0;
        gridParams.limit = -1;
        this.$scope.$emit('exportRecords', gridParams);
        this.isPopoverOpen = false;
    }

}
