
class NwfGlobalNavBase {
    public restrict = 'E';
    public transclude = true;
    public replace = true;
}

/* GlobalNav */
export class NwfGlobalNav extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnav';
    public template = '<header class="nwf-globalnav" ng-transclude></header>';
}
export function NwfGlobalNavFactory(): NwfGlobalNav {
    return new NwfGlobalNav();
}

/* GlobalNavPrimary */
export class NwfGlobalNavPrimary extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnavPrimary';
    public template = '<div class="nwf-globalnav-primary" ng-transclude></div>';
}
export function NwfGlobalNavPrimaryFactory(): NwfGlobalNavPrimary {
    return new NwfGlobalNavPrimary();
}

/* GlobalNavPrimary */
export class NwfAppTitle extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfAppTitle';
    public transclude = false;
    public scope = { title: '@' };
    public template = '<div class="nwf-globalnav-primary-apptitle"><h1 class="nwf-app-title">{{title}}</h1></div>';
}
export function NwfAppTitleFactory(): NwfAppTitle {
    return new NwfAppTitle();
}

/* GlobalNavPrimary */
export class NwfGlobalNavPrimaryTools extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnavPrimaryTools';
    public template = '<div class="nwf-globalnav-primary-tools" ng-transclude></div>';
}
export function NwfGlobalNavPrimaryToolsFactory(): NwfGlobalNavPrimaryTools {
    return new NwfGlobalNavPrimaryTools();
}

/* GlobalNavSecondary */
export class NwfGlobalNavSecondary extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnavSecondary';
    public template = '<div class="nwf-globalnav-secondary" ng-transclude></div>';
}
export function NwfGlobalNavSecondaryFactory(): NwfGlobalNavSecondary {
    return new NwfGlobalNavSecondary();
}

/* GlobalNavSecondaryMenus */
export class NwfGlobalNavSecondaryMenus extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnavSecondaryMenus';
    public template = '<div class="nwf-globalnav-secondary-menus" ng-transclude></div>';
}
export function NwfGlobalNavSecondaryMenusFactory(): NwfGlobalNavSecondaryMenus {
    return new NwfGlobalNavSecondaryMenus();

}

/* GlobalNavSecondarySearch */
export class NwfGlobalNavSecondarySearch extends NwfGlobalNavBase implements angular.IDirective {
    static NAME: string = 'nwfGlobalnavSecondarySearch';
    public template = '<div class="nwf-globalnav-secondary-search" ng-transclude></div>';
}
export function NwfGlobalNavSecondarySearchFactory(): NwfGlobalNavSecondarySearch {
    return new NwfGlobalNavSecondarySearch();
}
