import { NwfLogin, NwfLoginFactory} from './nwfLogin-directive';
import NwfLoginService from './nwfLogin-service';

import * as angular from 'angular';



class NwfLoginModule {

    static NAME: string = 'nwfLoginModule';

    static DEPENDENCIES: Array<string> = [

    ];


    private native: angular.IModule;

    constructor() {
        this.native = angular.module(NwfLoginModule.NAME, NwfLoginModule.DEPENDENCIES);
        this.native.directive(NwfLogin.NAME, NwfLoginFactory);
        this.native.service('nwfLoginService', NwfLoginService);

        this.native.directive('nwfLoginOverlay', function() {
            return {
                restrict: 'E',
                controller: function($rootScope, $element) {

                    var el:HTMLElement = $element.get(0);
                    $rootScope.$on('nwfHideLogin', function() {
                        el.classList.add('hide');
                    });
                    $rootScope.$on('nwfShowLogin', function() {
                        el.classList.remove('hide');
                    });

                }
            };
        });
    }


}

export default NwfLoginModule;

