
import * as angular from 'angular';
import { NwfAbout, NwfAboutFactory } from './nwfAbout/nwfAbout-directive';
import { NwfGlobalNav, NwfGlobalNavFactory, NwfGlobalNavPrimary, NwfGlobalNavPrimaryFactory, NwfGlobalNavSecondary, NwfGlobalNavSecondaryFactory } from './nwfGlobalNav/nwfGlobalNav-directive';
import { NwfAppTitle, NwfAppTitleFactory, NwfGlobalNavPrimaryTools, NwfGlobalNavPrimaryToolsFactory, NwfGlobalNavSecondaryMenus, NwfGlobalNavSecondaryMenusFactory} from './nwfGlobalNav/nwfGlobalNav-directive';
import { NwfGlobalNavSecondarySearch, NwfGlobalNavSecondarySearchFactory } from './nwfGlobalNav/nwfGlobalNav-directive';

import NwfLoginModule from './nwfLogin/nwfLogin-module';
import NwfLogoutModule from './nwfLogout/nwfLogout-module';
import { NwfChangePassword, NwfChangePasswordFactory} from './nwfChangePassword/nwfChangePassword-directive';
import { NwfLeftNav, NwfLeftNavFactory } from './nwfLeftNav/leftnav-component';

import NwfConfigProvider from '../nwfConfig-provider';

export default class NwfShellModule {

    static NAME: string = 'nwfShellModule';

    static DEPENDENCIES: Array<string> = [
        NwfLoginModule.NAME,
        NwfLogoutModule.NAME
    ];

    private native: angular.IModule;

    constructor() {

        this.initModules();
        this.native = angular.module(NwfShellModule.NAME, NwfShellModule.DEPENDENCIES);

        this.native.directive(NwfGlobalNav.NAME, NwfGlobalNavFactory);
        this.native.directive(NwfGlobalNavPrimary.NAME, NwfGlobalNavPrimaryFactory);
        this.native.directive(NwfGlobalNavSecondary.NAME, NwfGlobalNavSecondaryFactory);
        this.native.directive(NwfAppTitle.NAME, NwfAppTitleFactory);
        this.native.directive(NwfGlobalNavPrimaryTools.NAME, NwfGlobalNavPrimaryToolsFactory);
        this.native.directive(NwfGlobalNavSecondaryMenus.NAME, NwfGlobalNavSecondaryMenusFactory);
        this.native.directive(NwfGlobalNavSecondarySearch.NAME, NwfGlobalNavSecondarySearchFactory);
        this.native.directive(NwfAbout.NAME, NwfAboutFactory);
        this.native.component(NwfLeftNav.NAME, NwfLeftNavFactory());
        this.native.directive(NwfChangePassword.NAME, NwfChangePasswordFactory);

        this.native.constant('CHANGE_PASSWORD_EVENTS', {
            'GENERIC_SUCCESS': 'nwf.generic.success'
        });

    }

    initModules() {
        new NwfLoginModule();
        new NwfLogoutModule();
    }

}

